package pl.webnet.JaTrac;

import java.awt.*;
import java.awt.image.*;
import java.net.*;

class DiskImage implements ImageObserver
{
	int width = -1, height = - 1;
	boolean imgReady = false;
	int pixels[];

	public synchronized boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height)
	{
		if((infoflags & ImageObserver.WIDTH) != 0)
			this.width = width;

		if((infoflags & ImageObserver.HEIGHT) != 0)
			this.height = height;

		if((infoflags & ImageObserver.ERROR) != 0)
			System.out.println("Error!\n");

		if((infoflags & ImageObserver.ALLBITS) != 0)
		{
			// so that this objects knows that data is ready
			System.out.println("Image rady");
			imgReady = true;

			notifyAll();
			return false;
		}
			
		return true;
	}

	public synchronized void load()
	{
			try {
				while(imgReady == false)
					wait();
			} catch (InterruptedException e)
			      { e.printStackTrace(); }
	}

	public DiskImage(String filename)
	{
		PixelGrabber pGrabber;
		Image img = null;

		try
		{
			URL url = new URL("file://" + filename);

			System.out.println("Loading image: " + filename);

			img = Toolkit.getDefaultToolkit().getImage(url);

			width = img.getWidth(this);
			height = img.getHeight(this);
			if(height == -1)
				load();

			System.out.println("Size: " + width + "x" + height);

		} catch(MalformedURLException e)
		{ e.printStackTrace(); }

		pGrabber = new PixelGrabber(img, 0, 0, width, height, true);

		try {
			pGrabber.grabPixels();
		} catch (InterruptedException e)
		{ e.printStackTrace(); }

		pixels = (int [])pGrabber.getPixels();
	}
}

