package pl.webnet.JaTrac;

import java.awt.*;

class ImageBumpMap extends Texture
{
	int pixels[];
	int width, height;
	double divRec = 1 / 255.;


	public ImageBumpMap(String filename)
	{
		DiskImage di = new DiskImage(filename);

		pixels = di.pixels;
		width = di.width;
		height = di.height;
	}

	public Vec updateNormal(Vec n, Vec tan1Vec, Point uv)
	{
		double u = uv.x;
		double v = uv.y;
		Vec tan2Vec;
		double distortion;

		// we create vector perpendicular to tanget, so we have a surface
		tan2Vec = n.cross(tan1Vec);
		tan2Vec.unit();

		int s = (int)((width - 2) * u);
		int t = (int)((height - 2) * (1 - v));

		double du = (pixels[s + 1 + t * width] & 0xff) - (pixels[s + t * width] & 0xff);
		double dv = (pixels[s + (t + 1) * width] & 0xff) - (pixels[s + t * width] & 0xff);

		tan1Vec = tan1Vec.addVectorMultiple(n, -0.004 * dv);
		tan2Vec = tan2Vec.addVectorMultiple(n, -0.004 * du);

		Vec normal = tan1Vec.cross(tan2Vec);

/*
		int idx = (int)(u * (width - 1) + (int)((1 - v) * (height - 1) + .5) * width);
		int idx2 = idx + width + 1;
		if(idx2 > pixels.length)
			idx2 = 0;

		Vec normal = new Vec(n);
		distortion = (255 - (pixels[idx2] & 0xff) + (pixels[idx] & 0xff)) * divRec - 1.0;

		normal.setXYZ(
			normal.x + distortion * (par2Vec.z - par1Vec.z) * normal.y + distortion * (par1Vec.y - par2Vec.y) * normal.z,
			normal.y + distortion * (par2Vec.x - par1Vec.x) * normal.z + distortion * (par1Vec.z - par2Vec.z) * normal.x,
			normal.z + distortion * (par2Vec.y - par1Vec.y) * normal.x + distortion * (par1Vec.x - par2Vec.x) * normal.y
			);
*/
		normal.unit();
		
		return normal;
	}
}
