package pl.webnet.JaTrac;


class ImageColorMap extends Texture
{
	int pixels[];
	int width, height;

	public ImageColorMap(String filename)
	{
		DiskImage di = new DiskImage(filename);

		pixels = di.pixels;
		width = di.width;
		height = di.height;
	}

	public Spectrum updateSpectrum(Spectrum s, Point uv)
	{
		float r, g, b;
		float r0, g0, b0;
		float r1, g1, b1;
		float[] c0, c1, c2, c3;
		float u = (float)uv.x;
		float v = (float)uv.y;

		int idx = (int)(u * (width - 1) + (int)((1 - v) * (height - 1) + .5) * width);

		return s.create((pixels[idx] >> 16) & 0xff, (pixels[idx] >> 8) & 0xff, pixels[idx] & 0xff);
	}

}
