package pl.webnet.JaTrac;

import java.awt.image.*;
import java.awt.*;

class JaTrac
{
	public static void main(String[] args)
	{
		Loader loader = new Loader();
		Scene scene = loader.load(args[0]);
		/*
		//Camera cam = new Camera(new Point(8., 0., -40.), new Point(0., 0., 0.), new Vec(0., 1., 0.), 50., 640/480.);
		Camera cam = new Camera(new Point(0., 0., -70.), new Point(0., -4., 0.), new Vec(0., 1., 0.), 60., 640/480.);
		//Camera cam = new Camera(new Point(0., -40., 0.), new Point(0., 0., 0.), new Vec(0., 0., 1.), 50., 640/480.);
//		Screen scr = new Screen(1024, 768);
		Screen scr = new Screen(640, 480);
//		Screen scr = new Screen(320, 240);
		cam.attachScreen(scr);
		Ray primary, result = null;

		Scene scene = new Scene();
		Spectrum sp = new SpectrumRGB();
		scene.spectrum = sp;

		Surface dull = new Surface(1.0, 1.0, 0.1, 0.3, 0.0, 0.0);
		Surface shiny = new Surface(0.6, 0.9, 0.2, 0.8, 0.0, 0.0);
		Surface shiny2 = new Surface(1.0, 0.0, 0.0, 0.2, 0.0, 1.3);

//		scene.add(new Sphere(new Point(-10., 0., 0.), 10.0));
//		scene.add(new Sphere(new Point(10., 0., 0.), 10.0));
//		scene.add(new Sphere(new Point(-15., 10., 2.), 6.0));

		Sphere s1 = new Sphere(new Point(-2., -12., -10.), 5.0);
		s1.setSurface(shiny);
		s1.setSpectrum(sp.create(Spectrum.white));
		scene.add(s1);

		SphericalMapping sm1 = new SphericalMapping(new Point(0., -2., 0.), new Vec(0., -1., 0.), new Vec(0., 0., 1.));
		PlanarMapping pm1 = new PlanarMapping(new Point(0, 16, -20), new Point(20, 16, 0), new Point(0, 16, 20), new Point(-20, 16, 0));
		pm1.flipV = pm1.tileV = true;

		s1 = new Sphere(new Point(0., -2., 0.), 12.0);
		s1.setSurface(shiny2);
		s1.setSpectrum(sp.create(Spectrum.white));
		s1.mapping = sm1;
		scene.add(s1);

		s1 = new Sphere(new Point(-15., 10., 2.), 6.0);
		s1.setSurface(shiny);
		s1.setSpectrum(sp.create(Spectrum.white));
		scene.add(s1);


		Rectangle r1 = new Rectangle(new Point(-10, 16, 1), new Point(10, 16, 1), new Point(10, 16, -1), new Point(-10, 16, -1), true);
		r1.setSurface(dull);
		r1.setSpectrum(sp.create(Spectrum.white));
		r1.mapping = pm1;
//		r1.setColor(new Color(0.4f, 0.2f, 0.8f));
		scene.add(r1);

//		scene.add(new Rectangle(new Point(-1, 32, 1), new Point(1, 32, 1), new Point(1, 33, -1), new Point(-1, 33, -1), true));

		Triangle t1 = new Triangle(new Point(-30, -30, 0), new Point(-20, 0, 20), new Point(0, -20, 0));
		t1.setSurface(dull);
		t1.setSpectrum(sp.create(Spectrum.white));
		scene.add(t1);

	//	scene.add(new Triangle(new Point(-30, -30, 0), new Point(-20, 0, 20), new Point(0, -20, 0)));
//		scene.add(new Sphere(new Point(0., 0., 0.), 100.0));

		//createScene(scene, 5, 0, 0, 0, 14);

//		scene.add(new PointLight(new Point(-20., -30., -40.), Color.red));
		scene.add(new PointLight(new Point(-6., 14., -14.), sp.create(0.8, 0.8, 0.8)));
//		scene.add(new PointLight(new Point(0., -30., -60.), Color.green));
		scene.add(new PointLight(new Point(0., -30., -60.), sp.create(0.8, 0.8, 0.8)));
		scene.add(new PointLight(new Point(-6., 14., -14.), sp.create(Spectrum.blue)));
		scene.add(new LineLight(new Point(2., -30., -2.), new Point(3., -30., -2), sp.create(0.8, 0.8, 0.8)));
//		scene.add(new PointLight(new Point(2., -30., -2.), sp.create(0.8, 0.8, 0.8)));
*/
		scene.camera.render(scene);

		MTV.saveImage("output.mtv", scene.camera.screen.toImage());
		System.out.println("rays: " + Ray.count);
	}

	public static void createScene(Scene scene, int level, double x, double y, double z, double size)
	{
		Sphere s;
		Surface shiny = new Surface(0.6, 0.9, 0.2, 0.6, 0.0, 0.0);

		if(level == 0)
			return;

		scene.add(s = new Sphere(new Point(x, y, z), size));
		s.surface = shiny;

		createScene(scene, level-1, x, y, z + size, size / 2);
		createScene(scene, level-1, x, y, z - size, size / 2);

		createScene(scene, level-1, x + size, y + size, z, size / 2);
		createScene(scene, level-1, x - size, y + size, z, size / 2);
		createScene(scene, level-1, x + size, y - size, z, size / 2);
		createScene(scene, level-1, x - size, y - size, z, size / 2);
	}
}

