package pl.webnet.JaTrac;

import java.awt.*;

class LineLight extends Light
{
	Point end;
	final static int SUBDIVISION = 5;
	final static double START_X = 1. / (SUBDIVISION * 2);
	final static double STEP_X = 1. / SUBDIVISION;

	public LineLight(Point origin, Point end, Spectrum spectrum)
	{
		this.origin = new Point(origin);
		this.end = new Point(end);
		this.spectrum = spectrum;
	}

	public Double shadow(RayTree rt, Point hitPoint, Vec lightVec, double len)
	{
		double shadow = 1.;
		double x = START_X;
		Ray lightRay;

		for(int i = 0; i < SUBDIVISION - 1; i++)
		{
			double t = Math.random() / SUBDIVISION - START_X;
			t = x + t;
			x += STEP_X;

			Vec target = new Vec(new Point(end.x * t + origin.x * (1 - t),
				end.y * t + origin.y * (1 - t),
				end.z * t + origin.z * (1 - t)), hitPoint);

			lightRay = new Ray(hitPoint, target);

			if(rt.intersect(lightRay) != 0)
			{
				len = target.length();

				if(((Intersection)lightRay.intersections.first()).t < len - Ray.EPSILON)
					if(((Intersection)lightRay.intersections.first()).t >= Ray.EPSILON)
						shadow -= STEP_X;
			}
		}
		
//		System.out.println("shadow: " + shadow);
		return new Double(Math.max(0., shadow));
	}
}
