package pl.webnet.JaTrac;

import java.awt.image.*;
import java.io.*;

/**
 * This class contains convenience routines related to images in MTV format.
 * @author: Miloslaw Smyk (thorgal@amiga.com.pl)
 * @version: 1.0
 */

class MTV
{

/**
 * Save BufferedImage to disk file in MTV format.
 * @param		filename name of the file to create
 * @param		img BufferedImage to save
 */
	static public void saveImage(String filename, BufferedImage img)
	{
		int x, y;
		int w = img.getWidth();
		int h = img.getHeight();
		int buffer[] = new int[w * h];
		PixelGrabber pg;

		try
		{
			File outputFile = new File(filename);
			BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(outputFile));
		
			byte dims[] = new String(Integer.toString(w) + " " + Integer.toString(h) + "\n").getBytes();
			
			out.write(dims, 0, dims.length);

				pg = new PixelGrabber(img, 0, 0, w - 1, h - 1, buffer, 0, w);

				try {
					pg.grabPixels();
				} catch (InterruptedException e) {
					System.err.println("interrupted waiting for pixels!");
				return;
				}

				byte outbuf[] = new byte[w * 3];

				for(y = 0; y < h; y++)
				{
					for(x = 0; x < w; x++)
					{
						outbuf[x * 3] = (byte)((buffer[x + y * w] >> 16) & 0xff);
						outbuf[x * 3 + 1] = (byte)((buffer[x + y * w] >> 8) & 0xff);
						outbuf[x * 3 + 2] = (byte)((buffer[x + y * w]) & 0xff);
					}
					out.write(outbuf, 0, outbuf.length);
				}

			out.close();
		} catch (Exception e) { e.printStackTrace(); }
	}
}
