package pl.webnet.JaTrac;

import java.util.*;

/**
 * This class contains a complete scene with lists of all objects,
 * lights and mappings.
 * @author: Miloslaw Smyk (thorgal@amiga.com.pl)
 * @version: 1.0
 */

class Scene implements XmlSettable
{
	Camera camera;
	Spectrum spectrum;
	Vector primitives;
	Vector surfaces;
	Vector lights;


	public Scene()
	{
		primitives = new Vector();
		lights = new Vector();
		surfaces = new Vector();
	}

/**
 * Add new light to the scene.
 * @param		light the light to be put on the scene
 */
	public void add(Light light)
	{
		lights.add(light);
	}

	public void add(Primitive prim)
	{
		primitives.add(prim);
	}

	public String[] getParamArray()
	{
		String params[] = {
		};

		return params;
	}

	public void addObject(Object o)
	{
		String params[] = {
			"Camera", "setCamera",
			"Surface", "addSurface",
			"Spectrum", "setSpectrum",
			"Primitive", "add",
			".Light", "add"
		};

		ParamHelper.addObject(this, params, o);
	}

	public void setCamera(Camera cam) { camera = cam; }
	public void addSurface(Surface s) { surfaces.add(s); }
	public void addPrimitive(Primitive p) { primitives.add(p); }
	public void setSpectrum(Spectrum s) { spectrum = s; }
}
