package pl.webnet.JaTrac;

import java.util.*;

class Surface implements XmlSettable, Indexable
{
	double diffuseCoeff;
	double specularCoeff;
	double specularSizeCoeff;
	double reflectionCoeff;
	double transmissionCoeff;
	double refractionIndex;
	static List index = new Vector();
	String name;

	public Surface()
	{
		index.add(this);
	}
	
	public Surface(double d, double s, double ss, double r, double t, double ref)
	{
		index.add(this);
		diffuseCoeff = d;
		specularCoeff = s;
		specularSizeCoeff = 1 / (ss * ss);
		reflectionCoeff = r;
		transmissionCoeff = t;
		refractionIndex = ref;
		name = new String("unnamed");
	}

	public void setName(String name) { this.name = name; }
	public String getID() { return name; }

	public void setSpecularSize(String size)
	{
		double s = ParamHelper.extractDouble(size);
		specularSizeCoeff = 1/ (s * s);
	}

	public String[] getParamArray()
	{
		String params[] = {
			"name", "name", "",
			"diffuse", "diffuseCoeff", "",
			"specular", "specularCoeff", "",
			"specularsize", "", "setSpecularSize",
			"reflected", "reflectionCoeff", "",
			"transmitted", "transmissionCoeff", "",
			"refraction", "refractionIndex", ""
		};

		return params;
	}
	
	public void addObject(Object o) {}

}
